/*
*******************************************************************************
**
**  This device driver was created by Applilet2 for 78K0S/Kx1+
**  8-Bit Single-Chip Microcontrollers
**
**  Copyright(C) NEC Electronics Corporation 2002 - 2009
**  All rights reserved by NEC Electronics Corporation.
**
**  This program should be used on your own responsibility.
**  NEC Electronics Corporation assumes no responsibility for any losses
**  incurred by customers or third parties arising from the use of this file.
**
**  Filename :	 main.c
**  Abstract :	This file implements main function.
**  APIlib :	Applilet2 for 78K0S/Kx1+ V2.41 [9 Sep. 2008]
**
**  Device :	uPD78F9202
**
**  Compiler :	CC78K0S
**
**  Creation date:	2009/12/26
**  
*******************************************************************************
*/

/*
*******************************************************************************
**  Include files
*******************************************************************************
*/
#include "macrodriver.h"
#include "system.h"
#include "port.h"
#include "int.h"
#include "timer.h"
/* Start user code for include definition. Do not edit comment generated here */
/* End user code for include definition. Do not edit comment generated here */
#include "user_define.h"

/*
*******************************************************************************
**  Global define
*******************************************************************************
*/
/* Start user code for global definition. Do not edit comment generated here */
/* End user code for global definition. Do not edit comment generated here */


/*
**-----------------------------------------------------------------------------
**
**	Abstract:
**		This function  implements main function.
**
**	Parameters:
**		None
**
**	Returns:
**		None
**
**-----------------------------------------------------------------------------
*/
/* Start adding user code. Do not edit comment generated here */

unsigned char	count;
unsigned char	offcnt;
unsigned char	rec[16];
unsigned char	flg;
unsigned char	offlg;
unsigned char	mode_data;		/*2bit*/
unsigned char	code_data;		/*4bit*/
unsigned char	swin;
unsigned char	timer;


void	port_init(void)
{
	P4.0=0;P3.2=0;
	P2.0=0;P2.3=0;P2.2=0;P4.3=0;	
}

void	wait_time(unsigned int time)
{
	while(time!=0){
		time--;
	}
}

unsigned char	hantei(void)
{
unsigned char	data;
unsigned char	i;
unsigned char	m;

	data=0;
	if((rec[1]>=48)&&(rec[1]<=58)){data++;}
	mode_data=0;
	for(i=0;i<2;i++){
		mode_data=mode_data>>1;
		m=rec[2+i*2]+rec[3+i*2];
		if((m>=36)&&(m<=44)){
			mode_data=mode_data+0x80;
			
		}
	}
	mode_data=mode_data>>6;

	code_data=0;
	for(i=0;i<4;i++){
		code_data=code_data>>1;
		m=rec[6+i*2]+rec[7+i*2];
		if((m>=36)&&(m<=44)){
			code_data=code_data+0x80;
		}
	}
	code_data=code_data>>4;
	
	return	data;
}
void	ch_sw_input(void)		/* Dch only */
{
	swin=0;
	swin=swin+3;
}
void	bus_out(unsigned char data)
{
	if((data & 0x01)==0x01){P2.0=1;}
	if((data & 0x02)==0x02){P2.2=1;}
	if((data & 0x04)==0x04){P2.3=1;}
	if((data & 0x08)==0x08){P3.2=1;}
	
	wait_time(5);
	
	P4.3=1;
	
	wait_time(10);
	
	port_init();

}
void	main(void)
{
	port_init();
	count=0;offcnt=0;
	flg=0;offlg=0;
	timer=0;
	
	INTP0_Enable();
	TM00_Start();
	TMH1_Start();

	while (1) {
		ch_sw_input();
		if(flg==1){
			flg=0;
			if(hantei()==1){
				if(swin==mode_data){
					switch (code_data){
						case 0x08:bus_out(0x08);break;
						case 0x04:bus_out(0x04);break;
						case 0x02:bus_out(0x02);break;
						case 0x0c:bus_out(0x0c);break;
						case 0x0a:bus_out(0x0a);break;
						case 0x06:bus_out(0x06);break;
						case 0x0e:bus_out(0x0e);break;
						case 0x01:bus_out(0x01);break;
						case 0x09:bus_out(0x09);break;
						case 0x05:bus_out(0x05);break;
						case 0x0d:bus_out(0x0d);break;
						case 0x03:bus_out(0x03);break;
						case 0x0f:bus_out(0x0f);break;
					}
				}
				
				switch (mode_data){


				}
				offcnt=0;
			}
		}
		
		if(offlg==1){
			offlg=0;
			count=0;
			port_init();
		}

		
	}
}
/* End user code adding. Do not edit comment generated here */


